<?php
/* 
Plugin Name: Nofollow Case by Case 
Plugin URI: http://www.fob-marketing.de/ 
Description: Choose yourself if you want to make use of "nofollow" or not by adding /dontfollow to disliked comment links.
Version: 1.0 
Author: Oliver Bockelmann (fob marketing)  
Author URI: http://www.fob-marketing.de/ 
*/

/* 
** This Plugin is a modification of Follow URL (originally made for WordPress 1.5) available at http://blog.taragana.com. 
** Nofollow Case by Case, v. 1.0, 02-21-2007 | Copyright (c) 2007 fob marketing, Hamburg (All rights reserved). 

** THIS PLUGIN IS FOR WORDPRESS 1.x ONLY FOR NEWER VERSIONS PLEASE CHECK http://www.fob-marketing.de/marketing-blog/ FOR UPDATES!

** The "Nofollow Case by Case Plugin" comes with these features: ("Deutsche Beschreibung siehe unten")

    ------------------------------------------------------------------------------------------------------------- 
    |  1. Standard: rel="nofollow" will be stripped from all outgoing links by changing WordPress functions.    | 
    |  2. Possibility to add rel="nofollow" to comment links by simply adding /dontfollow to any unliked links. | 
    |  3. rel="external" will be stripped from all links including internal links.                              | 
    -------------------------------------------------------------------------------------------------------------  

** Redistribution and use in source and binary forms, with or without modification, are permitted provided that the 
** following conditions are met: 
1. Redistributions of source code must retain the above copyright notice, this list of conditions and the 
   following disclaimer in the documentation and/or other materials provided with the distribution.
2. The name of the author may not be used to endorse or promote products derived from this software without 
** specific prior written permission. 
** THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS  OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
** IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
** DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
** OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
** OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
** OF THE POSSIBILITY OF SUCH DAMAGE.

** "Nofollow Case by Case" in short: 
** Just upload this plugin in your plugins directory ( /wp-content/plugins ), activate it and give it a try. 
** The plugin automatically will strip nofollow attributes from authors as well as from links in comments. 
** Just add /dontfollow to any links that should be marked with rel="nofollow". 
** Example: http://www.not-this-one.com/dontfollow will automatically be changed to 
** http://www.not-this-one.com rel="nofollow" target="_blank"

** Deutsche Kurzbeschreibung: 
** Plugin hochladen, aktivieren und nutzen. 
** Standardmig wird das Nofollow-Attribut bei Links von Autoren und Kommentaren deaktiviert. 
** Wo rel="nofollow" zum Einsatz kommen soll, muss an den betreffenden Link einfach /dontfollow angehngt werden. 
** Beispiel: http://www.du-nicht.de/dontfollow 
** Im Originalcode wird /dontfollow dann automatisch entfernt und der Original-Link wird mit rel="nofollow" erweitert. 
*/ 

function make_normal_clickable($ret) { 
	$ret = ' ' . $ret; 
	/* In testing, the WordPress Team found arrays to be faster, so we make use of them from now on: */ 
	$ret = preg_replace( 
		array( 
			/* First two lines make sure that links get a nofollow tag if we want so by adding /dontfollow */ 
			'#([\s>])(https?)://([^\s<>{}()]+[^\s.,<>{}()])/(dontfollow)#i',
			'#(\s)www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^ <>{}()\n\r]*[^., <>{}()\n\r]?)?)/(dontfollow)#i',		
			'#([\s>])(https?)://([^\s<>{}()]+[^\s.,<>{}()])#i',
			'#(\s)www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^ <>{}()\n\r]*[^., <>{}()\n\r]?)?)#i',
			'#(\s)([a-z0-9\-_.]+)@([^,< \n\r]+)#i'),
		array(
			'$1<a href="$2://$3" rel="nofollow">$2://$3</a>',
			'$1<a href="http://www.$2.$3$4" rel="nofollow">www.$2.$3$4</a>',
			'$1<a href="$2://$3">$2://$3</a>',
			'$1<a href="http://www.$2.$3$4">www.$2.$3$4</a>',
			'$1<a href=\"mailto:$2@$3\">$2@$3</a>'),$ret); 
	/* Make sure that all dontfollow-links where stripped: */ 
	$ret = preg_replace("/\/dontfollow\"/","\" rel=\"nofollow\"",$ret); 
	/* This one is not in an array because we need it to run last, for cleanup of accidental links within links */ 
	$ret = preg_replace("#(<a( [^>]+?>|>))<a [^>]+?>([^>]+?)</a></a>#i", "$1$3</a>",$ret);
	$ret = trim($ret);
	return $ret;
}

/* If you don`t want your comment links to open in a new window delete target=\"blank\" in both functions: */ 

function strip_nofollow($ret) { 
	$ret = preg_replace("/rel='external nofollow'/","",$ret); 
	$ret = preg_replace("/rel=\"external nofollow\"/","",$ret); 
	return $ret; 
} 

function make_author_url_nofollow($ret) { 
	$ret = preg_replace("/\/dontfollow'/","' rel=\"nofollow\"",$ret); 
	$ret = preg_replace("/\/dontfollow\"/","\" rel=\"nofollow\"",$ret); 
	return $ret; 
} 

remove_filter('pre_comment_content', 'wp_rel_nofollow', 15); 
remove_filter('comment_text', 'make_clickable'); 
add_filter('comment_text', 'make_normal_clickable'); 
add_filter('get_comment_author_link', 'strip_nofollow'); 
add_filter('get_comment_author_link', 'make_author_url_nofollow'); 
?>